from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int, String

Vdb_Dump_2_10_8_V0_1_0 = CommandToolBuilder(tool="vdb_dump.2.10.8", base_command=["vdb-dump.2.10.8"], inputs=[ToolInput(tag="in_row_id_on", input_type=Boolean(optional=True), prefix="--row_id_on", doc=InputDocumentation(doc="print row id")), ToolInput(tag="in_colname_off", input_type=Boolean(optional=True), prefix="--colname_off", doc=InputDocumentation(doc="do not print column-names")), ToolInput(tag="in_in_hex", input_type=Boolean(optional=True), prefix="--in_hex", doc=InputDocumentation(doc="print numbers in hex")), ToolInput(tag="in_schema_dump", input_type=Boolean(optional=True), prefix="--schema_dump", doc=InputDocumentation(doc="prints the schema")), ToolInput(tag="in_table_enum", input_type=Boolean(optional=True), prefix="--table_enum", doc=InputDocumentation(doc="enumerate tables")), ToolInput(tag="in_column_enum", input_type=Boolean(optional=True), prefix="--column_enum", doc=InputDocumentation(doc="enumerate columns in extended form")), ToolInput(tag="in_column_enum_short", input_type=Boolean(optional=True), prefix="--column_enum_short", doc=InputDocumentation(doc="enumerate columns in short form")), ToolInput(tag="in_id_range", input_type=Boolean(optional=True), prefix="--id_range", doc=InputDocumentation(doc="prints id-range")), ToolInput(tag="in_without_sra", input_type=Boolean(optional=True), prefix="--without_sra", doc=InputDocumentation(doc="without sra-translation")), ToolInput(tag="in_obj_version", input_type=Boolean(optional=True), prefix="--obj_version", doc=InputDocumentation(doc="request vdb-version")), ToolInput(tag="in_obj_timestamp", input_type=Boolean(optional=True), prefix="--obj_timestamp", doc=InputDocumentation(doc="request object modification date")), ToolInput(tag="in_obj_type", input_type=Boolean(optional=True), prefix="--obj_type", doc=InputDocumentation(doc="report type of object")), ToolInput(tag="in_num_elem", input_type=Boolean(optional=True), prefix="--numelem", doc=InputDocumentation(doc="print only element-count")), ToolInput(tag="in_numele_msum", input_type=Boolean(optional=True), prefix="--numelemsum", doc=InputDocumentation(doc="sum element-count")), ToolInput(tag="in_b_lobbing", input_type=Boolean(optional=True), prefix="--blobbing", doc=InputDocumentation(doc="show blobbing")), ToolInput(tag="in_phys", input_type=Boolean(optional=True), prefix="--phys", doc=InputDocumentation(doc="enumeate physical columns")), ToolInput(tag="in_readable", input_type=Boolean(optional=True), prefix="--readable", doc=InputDocumentation(doc="enumeate readable columns")), ToolInput(tag="in_idx_report", input_type=Boolean(optional=True), prefix="--idx-report", doc=InputDocumentation(doc="enumeate all available index")), ToolInput(tag="in_gzip", input_type=Boolean(optional=True), prefix="--gzip", doc=InputDocumentation(doc="compress output using gzip")), ToolInput(tag="in_bzip_two", input_type=Boolean(optional=True), prefix="--bzip2", doc=InputDocumentation(doc="compress output using bzip2")), ToolInput(tag="in_info", input_type=Boolean(optional=True), prefix="--info", doc=InputDocumentation(doc="print info about accession")), ToolInput(tag="in_spot_groups", input_type=Boolean(optional=True), prefix="--spotgroups", doc=InputDocumentation(doc="show spotgroups")), ToolInput(tag="in_merge_ranges", input_type=Boolean(optional=True), prefix="--merge-ranges", doc=InputDocumentation(doc="merge and sort row-ranges")), ToolInput(tag="in_spread", input_type=Boolean(optional=True), prefix="--spread", doc=InputDocumentation(doc="show spread of integer values")), ToolInput(tag="in_append", input_type=File(optional=True), prefix="--append", doc=InputDocumentation(doc="append to output-file, if output-file is")), ToolInput(tag="in_max_length", input_type=Int(optional=True), prefix="--max_length", doc=InputDocumentation(doc="limits line length")), ToolInput(tag="in_indent_with", input_type=String(optional=True), prefix="--indent_with", doc=InputDocumentation(doc="indents the line")), ToolInput(tag="in_table", input_type=String(optional=True), prefix="--table", doc=InputDocumentation(doc="name of table to use")), ToolInput(tag="in_rows", input_type=String(optional=True), prefix="--rows", doc=InputDocumentation(doc="rows (default:all)")), ToolInput(tag="in_columns", input_type=String(optional=True), prefix="--columns", doc=InputDocumentation(doc="columns (default:all)")), ToolInput(tag="in_schema", input_type=File(optional=True), prefix="--schema", doc=InputDocumentation(doc="path to schema-file")), ToolInput(tag="in_dna_bases", input_type=String(optional=True), prefix="--dna_bases", doc=InputDocumentation(doc="print dna-bases")), ToolInput(tag="in_format", input_type=Int(optional=True), prefix="--format", doc=InputDocumentation(doc="output-format: csv ... comma-separated\nvalues on one line, xml ... xml-style\nwithout complete xml-frame, json ...\njson-style, piped ... 1 line per cell (\nrow-id, column-name: value ), tab ... 1\nline per row ( tab-separated values only\n), fastq ... FASTQ( 4 lines ) for each\nrow, fastq1 ... FASTQ( 4 lines ) for\neach fragment, fasta ... FASTA ( 2 lines\n) for each fragment if possible, fasta1\n... one FASTA-record for the whole\naccession (REFSEQ), fasta2 ... one\nFASTA-record for each REFERENCE in cSRA,\nqual ... QUAL( 2 lines ) for each row,\nqual1 ... QUAL ( 2 lines ) for each\nfragment if possible")), ToolInput(tag="in_exclude", input_type=String(optional=True), prefix="--exclude", doc=InputDocumentation(doc="exclude these columns")), ToolInput(tag="in_boolean", input_type=Boolean(optional=True), prefix="--boolean", doc=InputDocumentation(doc="defines how boolean's are printed, valid\nvalue: [1|T]")), ToolInput(tag="in_idx_range", input_type=String(optional=True), prefix="--idx-range", doc=InputDocumentation(doc="enumerate values and row-ranges of one")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--output-file", doc=InputDocumentation(doc="write output to this file")), ToolInput(tag="in_output_path", input_type=File(optional=True), prefix="--output-path", doc=InputDocumentation(doc="write output to this directory")), ToolInput(tag="in_output_buffer_size", input_type=Int(optional=True), prefix="--output-buffer-size", doc=InputDocumentation(doc="size of output-buffer, 0...none")), ToolInput(tag="in_ngc", input_type=File(optional=True), prefix="--ngc", doc=InputDocumentation(doc="<path> to ngc file")), ToolInput(tag="in_perm", input_type=File(optional=True), prefix="--perm", doc=InputDocumentation(doc="<path> to permission file")), ToolInput(tag="in_location", input_type=String(optional=True), prefix="--location", doc=InputDocumentation(doc="location in cloud")), ToolInput(tag="in_cart", input_type=File(optional=True), prefix="--cart", doc=InputDocumentation(doc="<path> to cart file")), ToolInput(tag="in_disable_multithreading", input_type=Boolean(optional=True), prefix="--disable-multithreading", doc=InputDocumentation(doc="disable multithreading")), ToolInput(tag="in_log_level", input_type=Int(optional=True), prefix="--log-level", doc=InputDocumentation(doc="Logging level as number or enum string.\nOne of\n(fatal|sys|int|err|warn|info|debug) or\n(0-6) Current/default is warn")), ToolInput(tag="in_option_file", input_type=File(optional=True), prefix="--option-file", doc=InputDocumentation(doc="Read more options and parameters from the")), ToolInput(tag="in_used", input_type=String(), position=0, doc=InputDocumentation(doc="-l|--line_feed <count>           number of line-feed's inbetween rows")), ToolInput(tag="in_index", input_type=String(), position=1, doc=InputDocumentation(doc="--cur-cache <size>            size of cursor cache")), ToolInput(tag="in_file_dot", input_type=File(), position=2, doc=InputDocumentation(doc="-h|--help                        print this message"))], outputs=[ToolOutput(tag="out_append", output_type=File(optional=True), selector=InputSelector(input_to_select="in_append", type_hint=File()), doc=OutputDocumentation(doc="append to output-file, if output-file is")), ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="write output to this file")), ToolOutput(tag="out_output_path", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_path", type_hint=File()), doc=OutputDocumentation(doc="write output to this directory"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Vdb_Dump_2_10_8_V0_1_0().translate("wdl", allow_empty_container=True)

